/***************************************************************************
*
*	File name : flashc_api.h
*	Function  : flashc driver (C17801)
*	Revision  :
*		July. 26, 2007	Yakushiji		First revision
*
****************************************************************************/

#ifndef	___FLASHC_API_H___
#define	___FLASHC_API_H___

typedef struct {
	unsigned short		flashWait;		// Access wait value
	unsigned long		TTBR;			// Trap Table base address
} T_FLASHC_CFG;


#define	FLASHC_ERASE_CHIP			0x0004
#define	FLASHC_ERASE_SECTOR			0x0002

#define	FLASHC_TOP_ADDRESS			0x20000
#ifdef	FOR_FLASH_128
#define	FLASHC_END_ADDRESS			0x3FFFF
#else
#define	FLASHC_END_ADDRESS			0x37FFF
#endif


// Macto function
#define	FlashcSetFlashWait(x)		FLSHC_WAIT = (unsigned short)x
#define	FlashcGetFlashWait(x)		(unsigned char)(FLSHC_WAIT & 0xFF)
#define	FlashcProtect()				FLSHC_PROT = 0x0000
#define	FlashcUnprotect()			FLSHC_PROT = 0x0096


#ifdef __cplusplus
extern "C" {
#endif

#ifndef	FOR_FLASHC_MINIMUM_API
extern void				FlashcInit(T_FLASHC_CFG*);
extern void				FlashcSetTTBR(unsigned long);
extern unsigned long	FlashcGetTTBR(void);
#endif
extern int				FlashcErase(unsigned char, unsigned long, unsigned long);
extern int				FlashcWrite(unsigned long, unsigned long, unsigned short*);

#ifdef __cplusplus
}
#endif

#endif	/* ___FLASHC_API_H___	*/

