/***************************************************************************
*
*	File name : gpio_drv.c
*	Function  : GPIO Driver (main)
*	Revision  :
*		08/06/2007	Nariai		First revision
*
****************************************************************************/

// Include Files
#include	"reg_801.h"
#include	"system.h"
#include	"gpio_api.h"


// Prototype
#ifdef	FOR_GPIO_USE_INTR
void GpioIntInit(T_GPIO_CFG *);
#endif

void GpioIntHdlr0(void);
void GpioIntHdlr1(void);
void GpioIntHdlr2(void);
void GpioIntHdlr3(void);
void GpioIntHdlr4(void);
void GpioIntHdlr5(void);
void GpioIntHdlr6(void);
void GpioIntHdlr7(void);

static void dummy(void);

#ifdef	FOR_GPIO_USE_INTR
static T_GPIO_CFG	Config;
#endif

#ifdef	FOR_GPIO_USE_INTR
/***************************************************************************
	GpioIntInit

	description	: Port interrupt handler 0
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntInit(T_GPIO_CFG *config){

	Config.Int0 = dummy;
	Config.Int1 = dummy;
	Config.Int2 = dummy;
	Config.Int3 = dummy;
	Config.Int4 = dummy;
	Config.Int5 = dummy;
	Config.Int6 = dummy;
	Config.Int7 = dummy;

	if(config->Int0 != NULL){
		Config.Int0 = config->Int0;
	}
	if(config->Int1 != NULL){
		Config.Int1 = config->Int1;
	}
	if(config->Int2 != NULL){
		Config.Int2 = config->Int2;
	}
	if(config->Int3 != NULL){
		Config.Int3 = config->Int3;
	}
	if(config->Int4 != NULL){
		Config.Int4 = config->Int4;
	}
	if(config->Int5 != NULL){
		Config.Int5 = config->Int5;
	}
	if(config->Int6 != NULL){
		Config.Int6 = config->Int6;
	}
	if(config->Int7 != NULL){
		Config.Int7 = config->Int7;
	}

	return;

}
#endif

/***************************************************************************
	GpioIntHdlr0

	description	: Port interrupt handler 0
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr0(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int0();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr1

	description	: Port interrupt handler 1
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr1(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int1();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr2

	description	: Port interrupt handler 2
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr2(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int2();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr3

	description	: Port interrupt handler 3
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr3(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int3();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr4

	description	: Port interrupt handler 4
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr4(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int4();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr5

	description	: Port interrupt handler 5
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr5(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int5();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr6

	description	: Port interrupt handler 6
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr6(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int6();
#endif

	return;

}


/***************************************************************************
	GpioIntHdlr7

	description	: Port interrupt handler 7
	argument	: None
	return: 	: None
***************************************************************************/
void GpioIntHdlr7(void){

#ifdef	FOR_GPIO_USE_INTR
	Config.Int7();
#endif

	return;

}

/***************************************************************************
	dummy

	description	: dummy
	argument	: None
	return: 	: None
***************************************************************************/
static void dummy(void){

	return;

}

